/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package database;

import entity.*;
import java.sql.*;
import java.util.*;

/**
 *
 * @author LibexiN
 */

public class CarDB
{
    private Connection myConnect = null;
    private Statement myStmt = null;

    public CarDB(ConnectDB myConnectDB) {
        myConnect = myConnectDB.getConnect();
        myStmt = myConnectDB.getStmt();
    }

    public List loadRecords(String ID_CAR, String ID_MANAGER, String ID_OFFICE, String ID_OFFICE_FOR_NO_SOLD) throws SQLException {
        List<Car> cars = new LinkedList<Car>();
        if (!myConnect.isClosed()) {
            ResultSet rs;
            if(ID_CAR != null)
                rs = myStmt.executeQuery("SELECT * FROM car WHERE id_car = " + ID_CAR);
            else if (ID_MANAGER != null)
                rs = myStmt.executeQuery("SELECT * FROM car WHERE id_car IN (SELECT id_car FROM sale WHERE id_manager = " + ID_MANAGER +")");
            else  if (ID_OFFICE != null)
                rs = myStmt.executeQuery("SELECT * FROM car WHERE id_office = " + ID_OFFICE);
            else if(ID_OFFICE_FOR_NO_SOLD != null)
                rs = myStmt.executeQuery("SELECT * FROM car WHERE id_car NOT IN (SELECT id_car FROM sale) AND id_office = " + ID_OFFICE_FOR_NO_SOLD);
            else
                rs = myStmt.executeQuery("SELECT * FROM car");
            while (rs.next()) {
                Car car =
                        new Car(rs.getInt("ID_CAR"),
                        rs.getInt("PRICE"),
                        rs.getInt("YEAR"),
                        rs.getString("COLOUR"),
                        rs.getInt("ID_MODEL"),
                        rs.getInt("ID_OFFICE"));
                cars.add(car);
            }
        }
        return cars;
    }

    public void addCar(int PRICE, int YEAR, String COLOUR,
            int ID_MODEL, int ID_OFFICE) throws Exception
    {
        try {
            if (!myConnect.isClosed()) {
                PreparedStatement prst = myConnect.prepareStatement("INSERT INTO car VALUES (CAR_SEQ.NEXTVAL,?1,?2,?3,?4,?5)");
                prst.setInt(1, PRICE);
                prst.setInt(2, YEAR);
                prst.setString(3, COLOUR);
                prst.setInt(4, ID_MODEL);
                prst.setInt(5, ID_OFFICE);
                prst.execute();
                prst.close();
            }
        } catch (Exception ex) {
            return;
        }
    }

    public void updateCar(int ID_CAR, int PRICE, int YEAR, String COLOUR, int ID_MODEL, int ID_OFFICE) throws Exception {
        if (!myConnect.isClosed()) {
            PreparedStatement prst = myConnect.prepareStatement("UPDATE car SET price=?1, year=?2, colour=?3, id_model=?4, id_office=?5 WHERE id_car = ?6");
            prst.setInt(1, PRICE);
            prst.setInt(2, YEAR);
            prst.setString(3, COLOUR);
            prst.setInt(4, ID_MODEL);
            prst.setInt(5, ID_OFFICE);
            prst.setInt(6, ID_CAR);
            prst.execute();
            prst.close();
        }
    }

    public void deleteOffice(int ID_CAR) throws Exception {
        if (!myConnect.isClosed()) {
            PreparedStatement prst_sale =
                    myConnect.prepareStatement("DELETE FROM sale WHERE id_car = " + ID_CAR);
            PreparedStatement prst_car =
                    myConnect.prepareStatement("DELETE FROM car WHERE id_car = " + ID_CAR);
            prst_sale.execute();
            prst_car.execute();
            prst_sale.close();
            prst_car.close();
        }
    }
}