package database;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import java.util.LinkedList;
import java.util.List;

import entity.Manager;

public class ManagerDB 
{
    private Connection myConnect = null;
    private Statement myStmt = null;

    public ManagerDB(ConnectDB myConnectDB) 
    {
        myConnect = myConnectDB.getConnect();
        myStmt = myConnectDB.getStmt();
    }

    public ManagerDB() {}

    public List loadRecords(String ID_MANAGER, String ID_OFFICE) throws Exception
    {
        List<Manager> managers = new LinkedList<Manager>();
        if(!myConnect.isClosed())
        {
            ResultSet rs;
            if(ID_MANAGER != null)
                rs = myStmt.executeQuery("SELECT * FROM manager WHERE id_manager = " + ID_MANAGER);
            else if (ID_OFFICE != null)
                rs = myStmt.executeQuery("SELECT * FROM manager WHERE id_office = " + ID_OFFICE);
            else
                rs = myStmt.executeQuery("SELECT * FROM manager ORDER BY first_name");
            while(rs.next())
            {
                Manager manager = new Manager(rs.getInt("ID_MANAGER"),
                                              rs.getString("FIRST_NAME"),
                                              rs.getString("LAST_NAME"),
                                              rs.getString("POST"),
                                              rs.getString("INN"),
                                              rs.getInt("ID_OFFICE"));
                managers.add(manager);
            }
        }
        return managers;
    }

    public List searchRecords(String[] arrayOption)
    {
        try
        {
            List<Manager> managers = new LinkedList<Manager>();
            String query = "";
            if (arrayOption[0] !=  null)
                query += ("first_name=\'" + arrayOption[0] + "\' AND ");
            if(arrayOption[1] !=  null)
                query += ("last_name=" + " \'" + arrayOption[1] + "\' AND ");
            if(arrayOption[2] !=  null)
                query += ("post=" + " \'" + arrayOption[2] + "\' AND ");
            query = query.substring(0, (query.length()-5));
            ResultSet rs = myStmt.executeQuery("SELECT * FROM manager WHERE " + query + "ORDER BY first_name,last_name");
            while (rs.next())
            {
                Manager manager = new Manager(rs.getInt("ID_MANAGER"),
                                              rs.getString("FIRST_NAME"),
                                              rs.getString("LAST_NAME"),
                                              rs.getString("POST"),
                                              rs.getString("INN"),
                                              rs.getInt("ID_OFFICE"));
                managers.add(manager);
            }
            return managers;
        }
        catch (Exception ex) {return null;}
    }

    public void addManager(int ID_OFFICE, String FIRST_NAME, String LAST_NAME,
                   String POST, String INN) throws SQLException
    {
        try {
            if (!myConnect.isClosed()) {
                PreparedStatement prst =
                        myConnect.prepareStatement("INSERT INTO manager VALUES (MANAGER_SEQ.NEXTVAL,?1,?2,?3,?4,?5)");
                prst.setString(1, FIRST_NAME);
                prst.setString(2, LAST_NAME);
                prst.setString(3, POST);
                prst.setString(4, INN);
                prst.setInt(5, ID_OFFICE);
                prst.execute();
                prst.close();
            }
        } catch (Exception ex) {
            return;
        }
    }

    public void updateManager(int ID_MANAGER, String FIRST_NAME, String LAST_NAME, String POST,
                  String INN, int ID_OFFICE) throws Exception
    {
        try {
            if (!myConnect.isClosed()) {
                PreparedStatement prst =
                        myConnect.prepareStatement("UPDATE manager SET first_name=?1, last_name=?2, post=?3, inn=?4, id_office=?5 WHERE id_manager = ?6");
                prst.setString(1, FIRST_NAME);
                prst.setString(2, LAST_NAME);
                prst.setString(3, POST);
                prst.setString(4, INN);
                prst.setInt(5, ID_OFFICE);
                prst.setInt(6, ID_MANAGER);
                prst.execute();
                prst.close();
            }
        } catch (Exception ex) {
            return;
        }
    }

    public void deleteManager(int ID_MANAGER) throws Exception
    {
        if (!myConnect.isClosed())
        {
            PreparedStatement prst_sale =
                myConnect.prepareStatement("DELETE FROM sale WHERE id_manager = " + ID_MANAGER);
            PreparedStatement prst_manager =
                myConnect.prepareStatement("DELETE FROM manager WHERE id_manager = " + ID_MANAGER);
            prst_sale.execute();
            prst_manager.execute();
            prst_sale.close();
            prst_manager.close();
        }
    }
}
