/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package database;

import entity.Manufacturer;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author LibexiN
 */

public class ManufacturerDB
{
    private Connection myConnect = null;
    private Statement myStmt = null;
    private List<Manufacturer> manufacturers;

    public ManufacturerDB(ConnectDB myConnectDB)
    {
        myConnect = myConnectDB.getConnect();
        myStmt = myConnectDB.getStmt();
    }

    public List loadRecords(String ID_MANUFACTURER, String ID_MODEL, String ID_OFFICE) throws Exception
    {
        manufacturers = new LinkedList<Manufacturer>();
        if(!myConnect.isClosed())
        {
            ResultSet rs;
            if(ID_MANUFACTURER != null)
                rs = myStmt.executeQuery("SELECT * FROM manufacturer WHERE id_manufacturer = " + ID_MANUFACTURER);
            else if(ID_MODEL != null)
                rs = myStmt.executeQuery("SELECT * FROM manufacturer WHERE id_manufacturer = (SELECT id_manufacturer FROM model WHERE id_model = " + ID_MODEL + ")");
            else if (ID_OFFICE != null)
                rs = myStmt.executeQuery("SELECT * FROM manufacturer WHERE id_manufacturer IN (SELECT id_manufacturer FROM model WHERE id_model IN (SELECT id_model FROM car WHERE id_office = " + ID_OFFICE + "))");
            else
                rs = myStmt.executeQuery("SELECT * FROM manufacturer ORDER BY name");
            while(rs.next())
            {
                Manufacturer manufacturer = new Manufacturer(rs.getInt("ID_MANUFACTURER"),
                                                             rs.getString("NAME"));
                manufacturers.add(manufacturer);
            }
        }
        return manufacturers;
    }

    public void addManufacturer(String NAME) throws Exception
    {
        try {
            if (!myConnect.isClosed()) {
                PreparedStatement prst =
                        myConnect.prepareStatement("INSERT INTO manufacturer VALUES (MANUFACTURER_SEQ.NEXTVAL,?1)");
                prst.setString(1, NAME);
                prst.execute();
                prst.close();
            }
        } catch (Exception es) {
            return;
        }
    }

    public void updateManufacturer(int ID_MANUFACTURER, String NAME) throws Exception
    {
        try {
            if (!myConnect.isClosed()) {
                PreparedStatement prst = myConnect.prepareStatement("UPDATE manufacturer SET name=?1 WHERE id_manufacturer=?2");
                prst.setString(1, NAME);
                prst.setInt(2, ID_MANUFACTURER);
                prst.execute();
                prst.close();
            }
        } catch (Exception es) {
            return;
        }
    }

    public void deleteManufacturer(int ID_MANUFACTURER) throws Exception
    {
        if (!myConnect.isClosed())
        {
            PreparedStatement prst_sale =
                myConnect.prepareStatement("DELETE FROM sale WHERE id_car IN (SELECT id_car " +
                                                                             "FROM car " +
                                                                             "WHERE id_model IN (SELECT id_model " +
                                                                                                "FROM model " +
                                                                                                "WHERE id_manufacturer = ?1))");
            PreparedStatement prst_car =
                myConnect.prepareStatement("DELETE FROM car WHERE id_model IN (SELECT id_model " +
                                                                              "FROM model " +
                                                                              "WHERE id_manufacturer = ?1)");
            PreparedStatement prst_model =
                myConnect.prepareStatement("DELETE FROM model WHERE id_manufacturer = ?1");
            PreparedStatement prst_manufacturer =
                myConnect.prepareStatement("DELETE FROM manufacturer WHERE id_manufacturer = ?1");
            prst_sale.setInt(1, ID_MANUFACTURER);
            prst_car.setInt(1, ID_MANUFACTURER);
            prst_model.setInt(1, ID_MANUFACTURER);
            prst_manufacturer.setInt(1, ID_MANUFACTURER);
            prst_sale.execute();
            prst_car.execute();
            prst_model.execute();
            prst_manufacturer.execute();
            prst_sale.close();
            prst_car.close();
            prst_model.close();
            prst_manufacturer.close();
        }
    }
}
