/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package database;

import entity.*;
import java.sql.*;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author LibexiN
 */

public class ModelDB
{
    private Connection myConnect = null;
    private Statement myStmt = null;

    public ModelDB(ConnectDB myConnectDB) {
        myConnect = myConnectDB.getConnect();
        myStmt = myConnectDB.getStmt();
    }

    public List loadRecords(String ID_MODEL, String ID_OFFICE, String ID_MANAGER, String ID_MANUFACTURER) throws SQLException {
        List<Model> models = new LinkedList<Model>();
        if (!myConnect.isClosed())
        {
            ResultSet rs;
            if(ID_MODEL != null)
                rs = myStmt.executeQuery("SELECT * FROM model WHERE id_model = " + ID_MODEL);
            else if (ID_OFFICE != null)
                rs = myStmt.executeQuery("SELECT * FROM model WHERE id_model IN (SELECT id_model FROM car WHERE id_office = " + ID_OFFICE + ")" );
            else if(ID_MANAGER != null)
                rs = myStmt.executeQuery("SELECT * FROM model WHERE id_model IN (SELECT id_model FROM car WHERE id_car IN (SELECT id_car FROM sale WHERE id_manager = " + ID_MANAGER +"))");
            else if(ID_MANUFACTURER != null)
                rs = myStmt.executeQuery("SELECT * FROM model WHERE id_manufacturer = " + ID_MANUFACTURER);
            else
                rs = myStmt.executeQuery("SELECT * FROM model ORDER BY mark,model");
            while (rs.next()) {
                Model model =
                        new Model(rs.getInt("ID_MODEL"),
                        rs.getString("MARK"),
                        rs.getString("MODEL"),
                        rs.getInt("MAX_SPEED"),
                        rs.getInt("POWER"),
                        rs.getInt("TANK_VALUE"),
                        rs.getString("GEAR_BOX"),
                        rs.getInt("WEIGHT"),
                        rs.getInt("ID_MANUFACTURER"));
                models.add(model);
            }
        }
        return models;
    }

    public List searchRecords(String[][] arrayOption)
    {
        try
        {
            List<Model> models = new LinkedList<Model>();
            String query = "";
            if (arrayOption[0][1] !=  null)
                query += ("mark=\'" + arrayOption[0][1] + "\' AND ");
            if(arrayOption[1][1] !=  null)
                query += ("max_speed" + arrayOption[1][0] + " \'" + arrayOption[1][1] + "\' AND ");
            if(arrayOption[2][1] !=  null)
                query += ("power" + arrayOption[2][0] + " \'" + arrayOption[2][1] + "\' AND ");
            if(arrayOption[3][1] !=  null)
                query += ("tank_value" + arrayOption[3][0] + " \'" + arrayOption[3][1] + "\' AND ");
            if (arrayOption[4][1] !=  null)
                query += ("gear_box=\'" + arrayOption[4][1] + "\' AND ");
            if(arrayOption[5][1] !=  null)
                query += ("weight" + arrayOption[5][0] + " \'" + arrayOption[5][1] + "\' AND ");
            query = query.substring(0, (query.length()-5));
            ResultSet rs = myStmt.executeQuery("SELECT * FROM model WHERE " + query + "ORDER BY mark,model");
            while (rs.next())
            {
                Model model =
                        new Model(rs.getInt("ID_MODEL"),
                        rs.getString("MARK"),
                        rs.getString("MODEL"),
                        rs.getInt("MAX_SPEED"),
                        rs.getInt("POWER"),
                        rs.getInt("TANK_VALUE"),
                        rs.getString("GEAR_BOX"),
                        rs.getInt("WEIGHT"),
                        rs.getInt("ID_MANUFACTURER"));
                models.add(model);
            }
            return models;
        }
        catch (Exception ex) {return null;}
    }

    public void addModel(String MARK, String MODEL, int MAX_SPEED,
            int POWER, int TANK_VALUE, String GEAR_BOX, int WEIGHT, int ID_MANUFACTURER) throws Exception
    {
        try {
            if (!myConnect.isClosed()) {
                PreparedStatement prst = myConnect.prepareStatement("INSERT INTO model VALUES (MODEL_SEQ.NEXTVAL,?1,?2,?3,?4,?5,?6,?7,?8)");
                prst.setString(1, MARK);
                prst.setString(2, MODEL);
                prst.setInt(3, MAX_SPEED);
                prst.setInt(4, POWER);
                prst.setInt(5, TANK_VALUE);
                prst.setString(6, GEAR_BOX);
                prst.setInt(7, WEIGHT);
                prst.setInt(8, ID_MANUFACTURER);
                prst.execute();
                prst.close();
            }
        } catch (Exception ex) {
            return;
        }
    }
    public void updateModel(int ID_MODEL, String MARK, String MODEL, int MAX_SPEED,
            int POWER, int TANK_VALUE, String GEAR_BOX, int WEIGHT, int ID_MANUFACTURER) throws Exception
    {
        try {
            if (!myConnect.isClosed()) {
                PreparedStatement prst = myConnect.prepareStatement("UPDATE model SET mark=?1, model=?2, max_speed=?3, power=?4, tank_value=?5, gear_box=?6, weight=?7, id_manufacturer=?8 WHERE id_model = ?9");
                prst.setString(1, MARK);
                prst.setString(2, MODEL);
                prst.setInt(3, MAX_SPEED);
                prst.setInt(4, POWER);
                prst.setInt(5, TANK_VALUE);
                prst.setString(6, GEAR_BOX);
                prst.setInt(7, WEIGHT);
                prst.setInt(8, ID_MANUFACTURER);
                prst.setInt(9, ID_MODEL);
                prst.execute();
                prst.close();
            }
        } catch (Exception ex) {
            return;
        }
    }

    public void deleteModel(int ID_MODEL) throws Exception
    {
        if (!myConnect.isClosed())
        {
            PreparedStatement prst_sale =
                myConnect.prepareStatement("DELETE FROM sale WHERE id_car IN (SELECT id_car FROM car WHERE id_model = " + ID_MODEL +")");
            PreparedStatement prst_car =
                myConnect.prepareStatement("DELETE FROM car WHERE id_model = " + ID_MODEL);
            PreparedStatement prst_model =
                myConnect.prepareStatement("DELETE FROM model WHERE id_model = " + ID_MODEL);
            prst_sale.execute();
            prst_car.execute();
            prst_model.execute();
            prst_sale.close();
            prst_car.close();
            prst_model.close();
        }
    }
}
