package database;

import entity.*;
import java.sql.*;
import java.sql.Date;
import java.util.*;

/**
 *
 * @author LibexiN
 */

public class SaleDB
{
    private Connection myConnect = null;
    private Statement myStmt = null;

    public SaleDB(ConnectDB myConnectDB)
    {
        myConnect = myConnectDB.getConnect();
        myStmt = myConnectDB.getStmt();
    }

    public List loadRecords(String ID_SALE, String ID_OFFICE, String ID_MANAGER) throws SQLException {
        List<Sale> sales = new LinkedList<Sale>();
        if (!myConnect.isClosed())
        {
            ResultSet rs;
            if(ID_SALE != null)
                rs = myStmt.executeQuery("SELECT * FROM sale WHERE id_sale = " + ID_SALE);
            else if(ID_OFFICE != null)
                rs = myStmt.executeQuery("SELECT * FROM sale WHERE id_car IN (SELECT id_car FROM car WHERE id_office = " + ID_OFFICE + ")");
            else if(ID_MANAGER != null)
                rs = myStmt.executeQuery("SELECT * FROM sale WHERE id_manager = " + ID_MANAGER);
            else
                rs = myStmt.executeQuery("SELECT * FROM sale");
            while (rs.next()) {
                Sale sale =
                        new Sale(rs.getInt("ID_SALE"),
                                 rs.getDate("DATA"),
                                 rs.getInt("PRICE"),
                                 rs.getInt("ID_MANAGER"),
                                 rs.getInt("ID_CAR"));
                sales.add(sale);
            }
        }
        return sales;
    }

    public void addSale(String DATA, int PRICE, int ID_MANAGER, int ID_CAR)
    {
        try
        {
            if (!myConnect.isClosed())
            {
                PreparedStatement prst = myConnect.prepareStatement("INSERT INTO sale VALUES (SALE_SEQ.NEXTVAL,?1,?2,?3,?4)");
                prst.setDate(1, Date.valueOf(DATA));
                prst.setInt(2, PRICE);
                prst.setInt(3, ID_MANAGER);
                prst.setInt(4, ID_CAR);
                prst.execute();
                prst.close();
            }
        }
        catch (Exception ex) {return;}
    }

    public void updateSale(int ID_SALE, String DATA, int PRICE) throws Exception
    {
        try
        {
            if (!myConnect.isClosed())
            {
                PreparedStatement prst = myConnect.prepareStatement("UPDATE sale SET data=?1, price=?2 WHERE id_sale = ?3");
                prst.setDate(1, Date.valueOf(DATA));
                prst.setInt(2, PRICE);
                prst.setInt(3, ID_SALE);
                prst.execute();
                prst.close();
            }
        }
        catch (Exception ex) {return;}
    }

    public void deleteSale(int ID_SALE) throws Exception
    {
        if (!myConnect.isClosed())
        {
            PreparedStatement prst_sale =
                    myConnect.prepareStatement("DELETE FROM sale WHERE id_sale = " + ID_SALE);
            prst_sale.execute();
            prst_sale.close();
        }
    }
}
