/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlet;

import database.*;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author LibexiN
 */
public class CarServlet extends HttpServlet
{
    private ConnectDB connectDB;
    private OfficeDB officeDB;
    private CarDB carDB;
    private ModelDB modelDB;
    private SaleDB saleDB;

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws Exception
    {
        response.setContentType("text/html;charset=UTF-8");
        request.setCharacterEncoding("UTF-8");
        connectDB = (ConnectDB) this.getServletContext().getAttribute("connect");
        officeDB = (OfficeDB) this.getServletContext().getAttribute("office");
        carDB = (CarDB) this.getServletContext().getAttribute("car");
        modelDB = (ModelDB) this.getServletContext().getAttribute("model");
        saleDB = (SaleDB) this.getServletContext().getAttribute("sale");

        if(request.getParameter("edit_page") != null)
        {
            if(request.getParameter("add") != null)
            {
                if(request.getParameter("set_add") != null)
                    procAdd(request);
                else
                    request.setAttribute("flagAdd", "...");
            }
            else if(request.getParameter("update") != null)
            {
                if(request.getParameter("set_update") != null)
                    procUpdate(request);
                else
                {
                    String ID_CAR = request.getParameter("id_car");
                    request.setAttribute("selected_car", carDB.loadRecords(ID_CAR,null,null,null));
                    request.setAttribute("flagUpdate", "...");
                }
            }
            else if(request.getParameter("delete") != null)
            {
                if(request.getParameter("delete_yes") != null)
                    procDelete(request);
                else if(request.getParameter("delete_no") == null)
                {
                    String ID_CAR = request.getParameter("id_car");
                    request.setAttribute("selected_car", carDB.loadRecords(ID_CAR,null,null,null));
                    request.setAttribute("flagDelete", "...");
                }
            }
            else if(request.getParameter("commit") != null)
                connectDB.commit();
            request.setAttribute("cars", carDB.loadRecords(null,null,null,null));
            request.setAttribute("offices", officeDB.loadRecords(null));
            request.setAttribute("models", modelDB.loadRecords(null,null,null,null));
            request.setAttribute("sales", saleDB.loadRecords(null,null,null));
            request.setAttribute("edit_page", "..."); // enable edit page
        }
        this.getServletContext().getRequestDispatcher("/car.jsp").forward(request, response);
    }

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (Exception ex) {
            Logger.getLogger(CarServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (Exception ex) {
            Logger.getLogger(CarServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void procAdd(HttpServletRequest request) throws Exception
    {
        String PRICE = request.getParameter("price");
        String YEAR = request.getParameter("year");
        String COLOUR = request.getParameter("colour");
        String ID_MODEL = request.getParameter("id_model");
        String ID_OFFICE = request.getParameter("id_office");

        if(PRICE == null || YEAR == null || COLOUR == null || ID_MODEL == null || ID_OFFICE == null)
            return;
        try{carDB.addCar(Integer.parseInt(PRICE), Integer.parseInt(YEAR), COLOUR, Integer.parseInt(ID_MODEL), Integer.parseInt(ID_OFFICE));}
        catch(Exception ex){return;}
    }

    public void procUpdate(HttpServletRequest request) throws Exception
    {
        String ID_CAR = request.getParameter("id_car");
        String PRICE = request.getParameter("new_price");
        String YEAR = request.getParameter("new_year");
        String COLOUR = request.getParameter("new_colour");
        String ID_MODEL = request.getParameter("new_model");
        String ID_OFFICE = request.getParameter("new_office");

        if (ID_CAR == null || PRICE == null || YEAR == null || COLOUR == null || ID_MODEL == null || ID_MODEL.equals("_blank") || ID_OFFICE == null || ID_OFFICE.equals("_blank"))
            return;
        try{carDB.updateCar(Integer.parseInt(ID_CAR), Integer.parseInt(PRICE), Integer.parseInt(YEAR), COLOUR, Integer.parseInt(ID_MODEL), Integer.parseInt(ID_OFFICE));}
        catch(Exception ex){return;}
    }

    public void procDelete(HttpServletRequest request) throws Exception
    {
        String ID_CAR = (String) request.getParameter("id_car");
        if (ID_CAR == null)
            return;
        carDB.deleteOffice(Integer.parseInt(ID_CAR));
    }
}
