/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlet;

import database.*;
import java.io.IOException;
import java.util.logging.*;
import javax.servlet.http.*;
import javax.servlet.ServletException;

/**
 *
 * @author LibexiN
 */

public class ManagerServlet extends HttpServlet
{
    ConnectDB connectDB;
    ManagerDB managerDB;
    OfficeDB officeDB;
    SaleDB saleDB;
    CarDB carDB;
    ModelDB modelDB;

    protected void processRequest(HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        response.setContentType("text/html;charset=UTF-8");
        request.setCharacterEncoding("UTF-8");
        connectDB = (ConnectDB) this.getServletContext().getAttribute("connect");
        managerDB = (ManagerDB) this.getServletContext().getAttribute("manager");
        officeDB = (OfficeDB) this.getServletContext().getAttribute("office");
        saleDB = (SaleDB) this.getServletContext().getAttribute("sale");
        carDB = (CarDB) this.getServletContext().getAttribute("car");
        modelDB = (ModelDB) this.getServletContext().getAttribute("model");

        if(request.getParameter("view_page") != null)
        {
            String ID_MANAGER = request.getParameter("id_manager");
            request.setAttribute("selected_manager", managerDB.loadRecords(ID_MANAGER,null));
            request.setAttribute("manager_sales", saleDB.loadRecords(null,null,ID_MANAGER));
            request.setAttribute("cars_saled", carDB.loadRecords(null,ID_MANAGER,null,null));
            request.setAttribute("models_saled", modelDB.loadRecords(null,null,ID_MANAGER,null));
            request.setAttribute("offices", officeDB.loadRecords(null));
            request.setAttribute("managers", managerDB.loadRecords(null,null));
            request.setAttribute("view_page", "..."); // enable view page
        }
        else if(request.getParameter("edit_page") != null)
        {
            if(request.getParameter("add") != null)
            {
                if(request.getParameter("set_add") != null)
                    procAdd(request);
                else
                {
                    request.setAttribute("offices", officeDB.loadRecords(null));
                    request.setAttribute("flagAdd", "...");
                }
            }
            else if(request.getParameter("update") != null)
            {
                if(request.getParameter("set_update") != null)
                    procUpdate(request);
                else
                {
                    String ID_MANAGER = request.getParameter("id_manager");
                    request.setAttribute("selected_manager", managerDB.loadRecords(ID_MANAGER,null));
                    request.setAttribute("flagUpdate", "...");
                }
            }
            else if(request.getParameter("delete") != null)
            {
                if(request.getParameter("delete_yes") != null)
                    procDelete(request);
                else if(request.getParameter("delete_no") == null)
                {
                    String ID_MANAGER = request.getParameter("id_manager");
                    request.setAttribute("selected_manager", managerDB.loadRecords(ID_MANAGER,null));
                    request.setAttribute("flagDelete", "...");
                }
            }
            else if(request.getParameter("commit") != null)
            {
                connectDB.commit();
            }
            request.setAttribute("offices", officeDB.loadRecords(null));
            request.setAttribute("managers", managerDB.loadRecords(null,null));
            request.setAttribute("edit_page", "..."); // enable edit page
        }
        else if(request.getParameter("search_page") != null)
        {
            if(request.getParameter("set_search") != null)
            {
                // строки - атрибуты, столбцы: условие и значение
                String arrayOption[] = {null,null,null};
                if(request.getParameter("first_name_check") != null)
                {
                    arrayOption[0] = request.getParameter("first_name");
                }
                if(request.getParameter("last_name_check") != null)
                {
                    arrayOption[1] = request.getParameter("last_name");
                }
                if(request.getParameter("post_check") != null)
                {
                    arrayOption[2] = request.getParameter("post");
                }
                request.setAttribute("offices", officeDB.loadRecords(null));
                request.setAttribute("find_managers", managerDB.searchRecords(arrayOption));
            }
            request.setAttribute("search_page", "..."); // enable search page
        }
        this.getServletContext().getRequestDispatcher("/manager.jsp").forward(request, response);
    } 

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
        try
        {
            processRequest(request, response);
        } catch (Exception ex)
        {
            Logger.getLogger(ManagerServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try
        {
            processRequest(request, response);
        } catch (Exception ex)
        {
            Logger.getLogger(ManagerServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void procAdd(HttpServletRequest request) throws Exception
    {
        String ID_OFFICE = request.getParameter("office");
        String FIRST_NAME = request.getParameter("first_name");
        String LAST_NAME = request.getParameter("last_name");
        String POST = request.getParameter("post");
        String INN = request.getParameter("inn");

        if(ID_OFFICE == null || ID_OFFICE.equals("_blank") || FIRST_NAME == null || LAST_NAME == null || POST == null || INN == null)
            return;
        try{managerDB.addManager(Integer.parseInt(ID_OFFICE), FIRST_NAME, LAST_NAME, POST, INN);}
        catch(Exception ex){return;}
    }

    public void procUpdate(HttpServletRequest request) throws Exception
    {
        String ID_MANAGER = request.getParameter("id_manager");
        String FIRST_NAME = request.getParameter("new_first_name");
        String LAST_NAME = request.getParameter("new_last_name");
        String POST = request.getParameter("new_post");
        String INN = request.getParameter("new_inn");
        String ID_OFFICE = request.getParameter("new_office");

        if (ID_OFFICE == null || ID_OFFICE.equals("_blank") || ID_MANAGER == null || FIRST_NAME == null || LAST_NAME == null || POST == null || INN == null)
            return;
        try{managerDB.updateManager(Integer.parseInt(ID_MANAGER), FIRST_NAME, LAST_NAME, POST, INN, Integer.parseInt(ID_OFFICE));}
        catch(Exception ex){return;}
    }
    
    public boolean procDelete(HttpServletRequest request) throws Exception
    {
        String ID_MANAGER = (String) request.getParameter("id_manager");
        if (ID_MANAGER == null)
            return false;
        managerDB.deleteManager(Integer.parseInt(ID_MANAGER));
        return true;
    }
}
