package servlet;

import database.*;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.*;

/**
 *
 * @author LibexiN
 */

public class ManufacturerServlet extends HttpServlet
{
    private ConnectDB connectDB;
    private ModelDB modelDB;
    private ManufacturerDB manufacturerDB;

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws Exception
    {
        response.setContentType("text/html;charset=UTF-8");
        request.setCharacterEncoding("UTF-8");
        connectDB = (ConnectDB) this.getServletContext().getAttribute("connect");
        modelDB = (ModelDB) this.getServletContext().getAttribute("model");
        manufacturerDB = (ManufacturerDB) this.getServletContext().getAttribute("manufacturer");

        if (request.getParameter("view_page") != null)
        {
            String ID_MANUFACTURER = request.getParameter("id_manufacturer");
//            request.setAttribute("selected_manufacturer", manufacturerDB.loadRecords(ID_MANUFACTURER,null,null));
            request.setAttribute("models_of_manufacturer", modelDB.loadRecords(null,null,null,ID_MANUFACTURER));
            request.setAttribute("view_page", "..."); // enable view page
        }
        else if(request.getParameter("edit_page") != null)
        {
            if(request.getParameter("add") != null)
            {
                if(request.getParameter("set_add") != null)
                    procAdd(request);
                else
                    request.setAttribute("flagAdd", "...");
            }
            else if(request.getParameter("update") != null)
            {
                if(request.getParameter("set_update") != null)
                    procUpdate(request);
                else
                {
                    String ID_MANUFACTURER = request.getParameter("id_manufacturer");
                    request.setAttribute("selected_manufacturer", manufacturerDB.loadRecords(ID_MANUFACTURER,null,null));
                    request.setAttribute("flagUpdate", "...");
                }
            }
            else if(request.getParameter("delete") != null)
            {
                if(request.getParameter("delete_yes") != null)
                    procDelete(request);
                else if(request.getParameter("delete_no") == null)
                {
                    String ID_MANUFACTURER = request.getParameter("id_manufacturer");
                    request.setAttribute("selected_manufacturer", manufacturerDB.loadRecords(ID_MANUFACTURER,null,null));
                    request.setAttribute("flagDelete", "...");
                }
            }
            else if(request.getParameter("commit") != null)
            {
                connectDB.commit();
            }
            request.setAttribute("manufacturers", manufacturerDB.loadRecords(null,null,null));
            request.setAttribute("edit_page", "..."); // enable edit page
        }
        this.getServletContext().getRequestDispatcher("/manufacturer.jsp").forward(request, response);
    } 

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (Exception ex) {
            Logger.getLogger(ManufacturerServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    } 

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (Exception ex) {
            Logger.getLogger(ManufacturerServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void procAdd(HttpServletRequest request) throws Exception
    {
        String NAME = request.getParameter("name");

        if(NAME == null)
            return;
        manufacturerDB.addManufacturer(NAME);
    }

    public void procUpdate(HttpServletRequest request) throws Exception
    {
        String ID_MANUFACTURER = request.getParameter("id_manufacturer");
        String NAME = request.getParameter("new_name");

        if (ID_MANUFACTURER == null || NAME == null)
            return;
        manufacturerDB.updateManufacturer(Integer.parseInt(ID_MANUFACTURER), NAME);
    }

    public void procDelete(HttpServletRequest request) throws Exception
    {
        String ID_MANUFACTURER = (String) request.getParameter("id_manufacturer");
        if (ID_MANUFACTURER == null)
            return;
        manufacturerDB.deleteManufacturer(Integer.parseInt(ID_MANUFACTURER));
    }
}
