package servlet;

import database.*;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author LibexiN
 */

public class SaleServlet extends HttpServlet
{
    private ConnectDB connectDB;
    private ManagerDB managerDB;
    private OfficeDB officeDB;
    private CarDB carDB;
    private ModelDB modelDB;
    private SaleDB saleDB;
    
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws Exception
    {
        response.setContentType("text/html;charset=UTF-8");
        request.setCharacterEncoding("UTF-8");
        connectDB = (ConnectDB) this.getServletContext().getAttribute("connect");
        managerDB = (ManagerDB) this.getServletContext().getAttribute("manager");
        officeDB = (OfficeDB) this.getServletContext().getAttribute("office");
        carDB = (CarDB) this.getServletContext().getAttribute("car");
        modelDB = (ModelDB) this.getServletContext().getAttribute("model");
        saleDB = (SaleDB) this.getServletContext().getAttribute("sale");

        if(request.getParameter("edit_page") != null)
        {
            if(request.getParameter("add") != null)
            {
                String ID_OFFICE = request.getParameter("selected_office");
                if(ID_OFFICE != null && !ID_OFFICE.equals("_blank"))
                {
                    request.setAttribute("no_sold_cars_office", carDB.loadRecords(null,null,null,ID_OFFICE));
                    request.setAttribute("managers_office", managerDB.loadRecords(null,ID_OFFICE));
                    request.setAttribute("show_sale", "...");
                    request.setAttribute("flagAdd", "...");
                }
                else if(request.getParameter("set_add") != null)
                    procAdd(request);
                else
                    request.setAttribute("flagAdd", "...");
            }
            else if(request.getParameter("update") != null)
            {
                if(request.getParameter("set_update") != null)
                    procUpdate(request);
                else
                {
                    String ID_SALE = request.getParameter("id_sale");
                    request.setAttribute("selected_sale", saleDB.loadRecords(ID_SALE,null,null));
                    request.setAttribute("flagUpdate", "...");
                }
            }
            else if(request.getParameter("delete") != null)
            {
                if(request.getParameter("delete_yes") != null)
                    procDelete(request);
                else if(request.getParameter("delete_no") == null)
                {
                    String ID_SALE = request.getParameter("id_sale");
                    request.setAttribute("selected_sale", saleDB.loadRecords(ID_SALE,null,null));
                    request.setAttribute("flagDelete", "...");
                }
            }
            else if(request.getParameter("commit") != null)
            {
                connectDB.commit();
            }
            request.setAttribute("sales", saleDB.loadRecords(null,null,null));
            request.setAttribute("managers", managerDB.loadRecords(null,null));
            request.setAttribute("offices", officeDB.loadRecords(null));
            request.setAttribute("cars", carDB.loadRecords(null,null,null,null));
            request.setAttribute("models", modelDB.loadRecords(null,null,null,null));
            request.setAttribute("edit_page", "..."); // enable edit page
        }
        this.getServletContext().getRequestDispatcher("/sale.jsp").forward(request, response);
    } 

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (Exception ex) {
            Logger.getLogger(SaleServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    } 

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (Exception ex) {
            Logger.getLogger(SaleServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void procAdd(HttpServletRequest request) throws Exception
    {
        String DATA = request.getParameter("data");
        String PRICE = request.getParameter("price");
        String ID_MANAGER = request.getParameter("id_manager");
        String ID_CAR = request.getParameter("id_car");

        if(DATA == null || PRICE == null || ID_MANAGER == null || ID_CAR == null)
            return;
        try{saleDB.addSale(DATA, Integer.parseInt(PRICE), Integer.parseInt(ID_MANAGER), Integer.parseInt(ID_CAR));}
        catch (Exception ex) {return;}
    }

    public void procUpdate(HttpServletRequest request) throws Exception
    {
        String ID_SALE = request.getParameter("id_sale");
        String DATA = request.getParameter("new_data");
        String PRICE = request.getParameter("new_price");

        if(ID_SALE == null || DATA == null || PRICE == null)
            return;
        try{saleDB.updateSale(Integer.parseInt(ID_SALE), DATA, Integer.parseInt(PRICE));}
        catch (Exception ex) {return;}
    }

    public void procDelete(HttpServletRequest request) throws Exception
    {
        String ID_SALE = (String) request.getParameter("id_sale");
        if (ID_SALE == null)
            return;
        saleDB.deleteSale(Integer.parseInt(ID_SALE));
    }
}
